function [MOM_sim] = MOM_func_alt(param_est)

% define parameters + switch off their values in MIRmodel.m
para.omegaP         = param_est(1);
para.rho_uphiP      = param_est(2);
para.sig_uphiP      = param_est(3);

MIRModel_version2
load temp1 % loads dynare output, simulated variables: yU tpU iLU iLEU

% wedge cyclicality
tempcor = corrcoef(ydifflagU,tpaU);
MOM_sim(1,1) = tempcor(2,1);
% wedge persistence
yy=tpaU(2:end);
xx=[tpaU(1:end-1) ones(length(yy),1)];
beta = (xx'*xx)\xx'*yy;
MOM_sim(2,1) = beta(1);
% wedge variance 
MOM_sim(3,1) = var(tpaU)/10000;
% relative variance long rates
MOM_sim(4,1) = var(iLU) / var(iLEU);