close all
clear all
clc

%% User control
% use_forward = 1; % indicator for whether forward rate implied long rate or market long rate is to be used

%% Reading data
LongRate = SetupForwardData;
ShortRate = SetupShortRateData;
[data,txt,raw]=xlsread('Marknadsforvantningar_2013.xlsx','Feb 2013','a1:i2095');

%% Generating plot of forward rate and path, February 2013
do = 1;
if do == 1
    forward         = LongRate.data(133:145,35);    % starting 2013 Q1
    path            = ShortRate.data(133:145,35);   % starting 2013 Q1
    repo_history    = data(1:1857,1);               % ending 2013-02-15
    
    size_path = size(path,1);
    size_repo_history = size(repo_history,1);
    
    forward = [nan(size_repo_history,1); forward];
    path    = [nan(size_repo_history,1); path];
    repo_history = [repo_history; nan(size_path,1)];
    
    repo_history_dates  = txt(4:1860,1);               % ending 2013-02-15
    forward_dates       = LongRate.dates(133:145,1);    % starting 2013 Q1

    % generating date numbers
    xdata       = datenum([repo_history_dates; forward_dates]);
    
    figure(1)
    ha = plot(xdata, repo_history,...
        xdata, path,...
        xdata, forward);
    set(ha(1), 'Linewidth', 2, 'Color',[0 0 0])
    set(ha(2), 'Linewidth', 2, 'Color',[0 0 0], 'Line', '--')
    set(ha(3), 'Linewidth', 2, 'Color',[0 0 0], 'Marker', '.')
    
    legend('Repo-rate', 'Repo-rate path', 'Forward rate')
%     title('Path implied and market three year yields')
%     set(gca,'XTick',xdata)
%     datetick('x','yyyy-mm-dd')

%%% change for visibility (Ferre) %%%
%     tick = [xdata(33); xdata(294); xdata(555); xdata(816); xdata(1076); ...
%         xdata(1337); xdata(1598); xdata(1858); xdata(1862); xdata(1866);...
%         xdata(1870)];
keyboard
    tick = [xdata(33); xdata(555); xdata(1076); ...
        xdata(1598); xdata(1862); xdata(1870)];
    
    set(gca,'XTick',tick)
    datetick('x','yyyy-mm','keepticks')
%%% %%% 
    axis tight

%%% Ferre %%%
    figure(2)
    ha = plot(xdata, repo_history,...
        xdata, path,...
        xdata, forward);
    set(ha(1), 'Linewidth', 2, 'Color',[0 1 0])
    set(ha(2), 'Linewidth', 2, 'Color',[0 0 1], 'Line', '-', 'Marker', 'o', 'MarkerSize',3)
    set(ha(3), 'Linewidth', 2, 'Color',[1 0 0], 'Line', '--')
    
    legend('Policy rate', 'Policy rate path', 'Market forward rates')
    tick = [xdata(33); xdata(555); xdata(1076); ...
        xdata(1598); xdata(1862); xdata(1870)];
    
    set(gca,'XTick',tick)
    datetick('x','yyyy-mm','keepticks')
%     axis tight

end

title('Sweden')
