close all
clear all
clc

%% Reading data
ShortRate = SetupShortRateData;
LongRate = SetupForwardData;


%% Generating plot of path implied and market yields
maturity = 4; % indicator for time to maturity 
              %  = 1: three months; = 2: 1 year; = 3: two years; = 4: three years

do = 1;
if do == 1
    policy_rounds = {
        'PPR 2007:1'	'2007-02-14'
        'PPR 2007:2'	'2007-06-19'
        'PPR 2007:3'	'2007-10-29'
        'PPU 2007:3'	'2007-12-18'
        'PPR 2008:1'	'2008-02-12'
        'PPU 2008:1'	'2008-04-22'
        'PPR 2008:2'	'2008-07-02'
        'PPU 2008:2'	'2008-09-03'
        'PPR 2008:3'	'2008-10-22'
        'PPU 2008:3'	'2008-12-03'
        'PPR 2009:1'	'2009-02-10'
        'PPU 2009:1'	'2009-04-20'
        'PPR 2009:2'	'2009-07-01'
        'PPU 2009:2'	'2009-09-02'
        'PPR 2009:3'	'2009-10-21'
        'PPU 2009:3'	'2009-12-15'
        'PPR 2010:1'	'2010-02-10'
        'PPU 2010:1'	'2010-04-19'
        'PPR 2010:2'	'2010-06-30'
        'PPU 2010:2'	'2010-09-01'
        'PPR 2010:3'	'2010-10-25'
        'PPU 2010:3'	'2010-12-14'
        'PPR 2011:1'	'2011-02-14'
        'PPU 2011:1'	'2011-04-19'
        'PPR 2011:2'	'2011-07-04'
        'PPU 2011:2'	'2011-09-06'
        'PPR 2011:3'	'2011-10-26'
        'PPU 2011:3'	'2011-12-19'
        'PPR 2012:1'	'2012-02-15'
        'PPU 2012:1'	'2012-04-17'
        'PPR 2012:2'	'2012-07-03'
        'PPU 2012:2'	'2012-09-05'
        'PPR 2012:3'	'2012-10-24'
        'PPU 2012:3'	'2012-12-17'
        'PPR 2013:1'	'2013-02-12'
        'PPU 2013:1'	'2013-04-16'
        'PPR 2013:2'	'2013-07-02'
        'PPU 2013:2'	'2013-09-04'
        
        'PPR 2013:3'    '2013-10-23'
        'PPU 2013:3'    '2013-12-16'
        'PPR 2014:1'    '2014-02-12'
        'PPU 2014:1'    '2014-04-08'
        'PPR 2014:2'    '2014-07-03'
        'PPU 2014:2'    '2014-09-03'
        
        'PPR 2014:3'    '2014-10-27'
        'PPU 2014:3'    '2014-12-15'
        'PPR 2015:1'    '2015-02-11'
        'PPR 2015:2'    '2015-04-28'
        };
    
    % generating date numbers
    xdata       = datenum(policy_rounds(:,2));
    
    figure(1)
    ha = plot(xdata, ShortRate.longrates(4,:),...
        xdata, LongRate.longrates(4,:));
    set(ha(1), 'Linewidth', 2, 'Color',[0 0 1], 'Line', '-', 'Marker', 'o', 'MarkerSize',3)
    set(ha(2), 'Linewidth', 2, 'Color',[1 0 0], 'Line', '--')
    legend('Average announced policy path', 'Average market forward rates')

%     title('Path implied and market three year yields')
    set(gca,'XTick',xdata)
%     datetick('x','yyyy-mm-dd')

%%% change for visibility (Ferre) %%%
    set(gca,'XTick',xdata(2:6:end))
    datetick('x','yyyy-mm','keepticks')
%%% %%% 

    axis tight
end

title('Sweden')

