
load DataFiguresVicke.mat
Dates = datestr(DataFiguresVicke.Date,'yyyy-mm-dd');
DatesQ = strcat(num2str(year(DataFiguresVicke.Date,'yyyy-mm-dd')), '-0', num2str(month(DataFiguresVicke.Date,'yyyy-mm-dd')./3));
Datesnum = datenum(DataFiguresVicke.Date,'yyyy-mm-dd');

ind = find(strcmpi(DataFiguresVicke.Date,'2014-12-31'));

h(1) = figure;
hold on
plot(1:length(DatesQ(1:ind)), DataFiguresVicke.avg_exp_rate_1y(1:ind), '-b', 'Linewidth', 2, 'Marker', 'o', 'MarkerSize',3)
plot(1:length(DatesQ(1:ind)), DataFiguresVicke.avg_forward_12m(1:ind), '--r', 'Linewidth', 2)
xlim([1 ind])
title('New Zealand')
legend('Average announced policy path', 'Average market forward rates', 'Location', 'NE')
box('on')
set(gca, 'XTick',[1:8:length(DatesQ)], 'XTickLabel', DatesQ(1:8:end,:))
hold off

h(2) = figure;
hold on
plot(1:length(DatesQ(1:ind)), DataFiguresVicke.avg_exp_rate_2y(1:ind), '-b', 'Linewidth', 2, 'Marker', 'o', 'MarkerSize',3)
plot(1:length(DatesQ(1:ind)), DataFiguresVicke.avg_forward_24m(1:ind), '--r', 'Linewidth', 2)
xlim([1 ind])
title('New Zealand')
legend('Average announced policy path', 'Average market forward rates', 'Location', 'NE')
box('on')
set(gca, 'XTick',[1:8:length(DatesQ)], 'XTickLabel', DatesQ(1:8:end,:))
hold off

i = 35;

forward_rate = [ DataFiguresVicke.Policy_rate(i) ; ...
                 DataFiguresVicke.forward_3m(i) ; ...
                 DataFiguresVicke.forward_6m(i) ; ...
                 DataFiguresVicke.forward_9m(i) ; ...
                 DataFiguresVicke.forward_12m(i) ; ...
                 DataFiguresVicke.forward_15m(i) ; ...
                 DataFiguresVicke.forward_18m(i) ; ...
                 DataFiguresVicke.forward_21m(i) ; ...
                 DataFiguresVicke.forward_24m(i) ];
exp_policy_rate = [ DataFiguresVicke.Policy_rate(i) ; ...
                    DataFiguresVicke.exp_policy_rate_3m(i) ; ...
                    DataFiguresVicke.exp_policy_rate_6m(i) ; ...
                    DataFiguresVicke.exp_policy_rate_9m(i) ; ...
                    DataFiguresVicke.exp_policy_rate_12m(i) ; ...
                    DataFiguresVicke.exp_policy_rate_15m(i) ; ...
                    DataFiguresVicke.exp_policy_rate_18m(i) ; ...
                    DataFiguresVicke.exp_policy_rate_21m(i) ; ...
                    DataFiguresVicke.exp_policy_rate_24m(i) ];

h(3) = figure;
hold on
plot(1:i, DataFiguresVicke.Policy_rate(1:i), '-g', 'Linewidth', 2)
plot(i:i+8, exp_policy_rate, '-b', 'Linewidth', 2, 'Marker', 'o', 'MarkerSize',3)
plot(i:i+8, forward_rate, '--r', 'Linewidth', 2)
xlim([1 i+8])
title('New Zealand')
legend('Policy rate', 'Policy rate path', 'Market forward rates', 'Location', 'NE')
box('on')
set(gca, 'XTick',[1:8:length(DatesQ)], 'XTickLabel', DatesQ(1:8:end,:))
hold off

savefig(h,'figures2.fig')
