clear all
% close all
clc
restoredefaultpath
path(path,'C:/Program Files/Exe/NotYADA/Dynare/4.1.0/matlab')
% addpath('S:\APP\APP_Modellenheten\Projekt\2013\MultipleInterestRateProject\Jens\Dynare\ComparingModels')

    
%% Parameter setting new version
% Parameters, household and producers
para.betaP     = (1.026417)^(-1/4);     % discount factor unrestricted households
para.sigmaP     = 1;        % inverse of IES
para.vphiP      = 3;        % Frisch elasticity
para.alphaP     = 0.75;     % Prob. of no price change
para.thetaP     = 11;       % Elas. of sub. intermediate goods
para.tauP       = 0.00001;   % Elasticity of fin. cost. wrt. restricted bond holdings


% implied parameters
para.kappaP = (1 - para.alphaP) * (1 - para.alphaP * para.betaP)...
    / para.alphaP;                                                          % slope of NKPC

% Monetary policy parameters
para.rhoiP      = 0.85;     % Inertia MP rule
para.psipiP     = 2;        % Reaction to inflation
para.psiyP      = 0.5/4;    % Reaction to output

% Market clearing parameters
para.omegaP     =     0.27786;   % Fraction of unrestricted agents, SWE = 0.2779

% Stochastic process parameters
para.rho_ucP    = 0;      % autocorr. cons. pref
para.rho_ulP    = 0;      % autocorr. labor supply
para.rho_uzP    = 0;   % autocorr. productivity
para.rho_ugP    = 0;      % autocorr. gov spend
para.rho_uiP    = 0;      % autocorr. monetary
para.rho_uphiP  = 0.77127; % autocorr. transaction costs, SWE = 0.7713

para.sig_ucP    = 0;      % std. dev. cons. pref
para.sig_ulP    = 0;      % std. dev. labor supply
para.sig_uzP    = 0;      % std. dev. productivity
para.sig_ugP    = 0;      % std. dev. gov spend
para.sig_uiP    = 0;      % std. dev. monetary
para.sig_uphiP  = 0.00864; % std. dev. transaction costs, SWE = 0.0086

% Steady state values
% free steady state values
para.gyS    = 0.3;          % Government spending as fraction of output

% Implied steady state values
para.wS     = (para.thetaP - 1) / para.thetaP;                              % wage rate
para.cS     = ((1-para.gyS) ^ para.vphiP * (para.thetaP - 1)...
    / para.thetaP) ^ (1/(para.vphiP + para.sigmaP));                        % aggregate consumption
para.yS     = para.cS ^ (-para.sigmaP / para.vphiP) * ((para.thetaP - 1)...
    / para.thetaP) ^ (1 / para.vphiP);                                      % aggregate output
para.gS     = para.yS * para.gyS;                                           % aggregate public spending
para.tS     = -para.gS;                                                     % transfers
para.dS    = 1 / para.thetaP * para.yS;                                     % dividends

save para para
dynare MIR_version2

IRFs = oo_.irfs;
save IRFs IRFs

