var xiuU, xirU, cuU, crU, cU, gU, luU, lrU, lU, bCBuU, bCBU, bMuU, bMrU, bMU, wU, piU, iCBU, iMU, tU, yU, dU, phiU, 
iLCBU, iLMU, tpU, iaU, tpaU, piaU, yaU, piyyU, iLaU,

ucU, ulU, uzU, ugU, uiU, uphiU,

iU, iLU, iLEU, ydifflagU;

varexo ucU_eps, ulU_eps, uzU_eps, ugU_eps, uiU_eps, utU_eps, uphiU_eps ;

parameters betaP, sigmaP, vphiP, alphaP, thetaP, tauP, 
kappaP, 
rhoiP, psipiP, psiyP, 
omegaP, 
rho_ucP, rho_ulP, rho_uzP, rho_ugP, rho_uiP, rho_uphiP, 
sig_ucP, sig_ulP, sig_uzP, sig_ugP, sig_uiP, sig_uphiP, 

gyS, wS, cS, yS, gS, tS, dS;

load para;
// Parameters, household and producers
set_param_value('betaP',para.betaP);
set_param_value('sigmaP',para.sigmaP);
set_param_value('vphiP',para.vphiP);
set_param_value('alphaP',para.alphaP);
set_param_value('thetaP',para.thetaP);
set_param_value('tauP',para.tauP);
set_param_value('kappaP',para.kappaP);

// Monetary policy parameters
set_param_value('rhoiP',para.rhoiP);
set_param_value('psipiP',para.psipiP);
set_param_value('psiyP',para.psiyP);

// Market clearing parameters
set_param_value('omegaP',para.omegaP);

// Stochastic process parameters
set_param_value('rho_ucP',para.rho_ucP);
set_param_value('rho_ulP',para.rho_ulP);
set_param_value('rho_uzP',para.rho_uzP);
set_param_value('rho_ugP',para.rho_ugP);
set_param_value('rho_uiP',para.rho_uiP);
set_param_value('rho_uphiP',para.rho_uphiP);

set_param_value('sig_ucP',para.sig_ucP);
set_param_value('sig_ulP',para.sig_ulP);
set_param_value('sig_uzP',para.sig_uzP);
set_param_value('sig_ugP',para.sig_ugP);
set_param_value('sig_uiP',para.sig_uiP);
set_param_value('sig_uphiP',para.sig_uphiP);

// Steady state values
set_param_value('gyS',para.gyS);
set_param_value('wS',para.wS);
set_param_value('cS',para.cS);
set_param_value('yS',para.yS);
set_param_value('gS',para.gS);

set_param_value('tS',para.tS);
set_param_value('dS',para.dS);

// MODEL
model(linear);

// unrestricted household foc's
//(1) lagrange multiplier
xiuU = ucU - sigmaP * cuU ;

//(2) optimal labor supply
ulU + vphiP * luU = xiuU + wU ;

//(3) euler equation CB short bond
xiuU = xiuU(+1) + iCBU - piU(+1);

//(4) euler equation M short bond
xiuU = xiuU(+1) + iMU - phiU - piU(+1);

// restricted household foc's
//(5) lagrange multiplier
xirU = ucU - sigmaP * crU ;

//(6) optimal labor supply
ulU + vphiP * lrU = xirU + wU ;

//(7) combined euler equation long bonds
xirU = xirU(+1) + iMU - piU(+1);

// production sector
//(8) NK phillips-curve
piU = kappaP * (wU - uzU) + betaP * piU(+1) ;

// Government 
//(9) budget constraint
tU = gU;

//(10) evolution CB short bond
bCBU = 0;

//(11) evolution M short bond
bMU = 0;

//(12) Monetary policy rule
iCBU = rhoiP * iCBU(-1) + (1 - rhoiP) * (psipiP * piU + psiyP * yU) + uiU;
//iU = rhoiP * iU(-1) + (1 - rhoiP) * (psipiP * piU + psiyP * yU) - (1 - omegaP) * (tpU - kappaP * betatildeP * tpU(+1)) / (1 - kappaP * betatildeP) + uiU;
//iU = rhoiP * iU(-1) + (1 - rhoiP) * (psipiP * piU + psiyP * yU - (1 - omegaP) * (tpU) / (1 - kappaP * betatildeP))  + uiU;

// market clearing conditions
//(13) labor market clearing
lU = omegaP * luU + (1 - omegaP) * lrU;

//(14) goods market clearing
uzU + lU = yU;

//(15) definition government spending process
gU = yU + (1 - gyS) * ugU;

//(16) aggregate output
yU = cU + gyS * ugU;

//(17) aggregate consumption
cU = omegaP * cuU + (1 - omegaP) * crU;

//(18) market clearing M short bond
bMU = omegaP * bMuU + (1 - omegaP) * bMrU;

//(19) market clearing short bonds
bCBU = omegaP * bCBuU;

//(20) restricted household budget constraint
cS * crU / yS + bMrU = bMrU(-1) / betaP + wS * (wU + lrU) + tS * tU / yS + dS * dU / yS;

//(21) definition of dividends
dS * dU / yS = yU - wS * (wU + lU);

//(22) definition phiU
phiU =  tauP * bMuU + uphiU;

//(24) definition of three year yield, CB 
iLCBU = (iCBU + iCBU(+1) + iCBU(+2) + iCBU(+3) + iCBU(+4) + iCBU(+5) + iCBU(+6) + 
	       iCBU(+7) + iCBU(+8) + iCBU(+9) + iCBU(+10) + iCBU(+11)) / 12;

//(25) definition of three year yield, M 
iLMU = (iMU + iMU(+1) + iMU(+2) + iMU(+3) + iMU(+4) + iMU(+5) + iMU(+6) + 
	     iMU(+7) + iMU(+8) + iMU(+9) + iMU(+10) + iMU(+11)) / 12;

//(26) correct definition of wedge, not same as in SMM exercise
tpU = iLCBU-iLMU;

//(27) annualized short interest rate in percent
iaU = 400 * iCBU;

//(28) annualized term premium in basis points
tpaU = 40000 * tpU;

//(29) annualized inflation in percent
piaU = 400 * piU;

//(30) annualized output gap in percent
yaU = 100 * yU;

// (31) annualized inflation (year/year) in percent
piyyU = 100 * (piU - piU(-4));

// (32) annualized long interest rate in percent
iLaU = 400 * iLU;


////////////// definitions required for SMM /////////////
// (40) annualized 4 quarter gdp growth
ydifflagU = 1 * (yU - yU(-4));


iU = iCBU;
iLU = iLMU;
iLEU = iLCBU;

// shock equations

//(A1)
ucU 	= rho_ucP 	* ucU(-1) 	+ sig_ucP 	* ucU_eps;

//(A2)
ulU 	= rho_ulP 	* ulU(-1) 	+ sig_ulP 	* ulU_eps;

//(A3)
uzU 	= rho_uzP 	* uzU(-1) 	+ sig_uzP 	* uzU_eps;

//(A4)
ugU 	= rho_ugP 	* ugU(-1) 	+ sig_ugP 	* ugU_eps;

//(A5)
uiU 	= rho_uiP 	* uiU(-1) 	+ sig_uiP 	* uiU_eps;

//(A6)
//uphiU 	= rho_uphiP 	* uphiU(-1)	+ sig_uphiP 	* uphiU_eps;
uphiU 	= rho_uphiP 	* uphiU(-1)	+ (1 - rho_uphiP) * sig_uphiP * uphiU_eps;

end;

/////////////////////////////////////
/////////////////////////////////////

shocks;
var ucU_eps     = 1;
var ulU_eps     = 1;
var uzU_eps   	= 1;
var ugU_eps     = 1;
var uiU_eps    	= 1;
var uphiU_eps  	= 1;
end;

//check;

stoch_simul(irf=500, nograph) yaU, piaU, piyyU, iaU, iLaU, tpaU, uphiU;



