%% book keeping
clear all
close all
clc

restoredefaultpath
% addpath(genpath('S:\APP\APP_Modellenheten\Projekt\2013\MultipleInterestRateProject\Jens\Empirical\Scenario'))

policy_rounds = {  
    'PPR 2007:1'	'2007-02-14'    '2007q1'
    'PPR 2007:2'	'2007-06-19'    '2007q2'
    ''              ''              '2007q3'
    'PPU 2007:1'	'2007-12-18'    '2007q4'
    'PPR 2008:1'	'2008-02-12'    '2008q1'
    'PPU 2008:1'	'2008-04-22'    '2008q2'
%     'PPR 2008:2'	'2008-07-02'    '2008q3'
    'PPU 2008:2'	'2008-09-03'    '2008q3'
%     'PPR 2008:3'	'2008-10-22'    '2008q4'
    'PPU 2008:3'	'2008-12-03'    '2008q4'
    'PPR 2009:1'	'2009-02-10'    '2009q1'
    'PPU 2009:1'	'2009-04-20'    '2009q2'
%     'PPR 2009:2'	'2009-07-01'    '2009q3'
    'PPU 2009:2'	'2009-09-02'    '2009q3'
%     'PPR 2009:3'	'2009-10-21'    '2009q4'
    'PPU 2009:3'	'2009-12-15'    '2009q4'
    'PPR 2010:1'	'2010-02-10'    '2010q1'
    'PPU 2010:1'	'2010-04-19'    '2010q2'
%     'PPR 2010:2'	'2010-06-30'    '2010q3'
    'PPU 2010:2'	'2010-09-01'    '2010q3'
%     'PPR 2010:3'	'2010-10-25'    '2010q4'
    'PPU 2010:3'	'2010-12-14'    '2010q4'
    'PPR 2011:1'	'2011-02-14'    '2011q1'
    'PPU 2011:1'	'2011-04-19'    '2011q2'
%     'PPR 2011:2'	'2011-07-04'    '2011q3'
    'PPU 2011:2'	'2011-09-06'    '2011q3'
%     'PPR 2011:3'	'2011-10-26'    '2011q4'
    'PPU 2011:3'	'2011-12-19'    '2011q4'
    'PPR 2012:1'	'2012-02-15'    '2012q1'
    'PPU 2012:1'	'2012-04-17'    '2012q2'
%     'PPR 2012:2'	'2012-07-03'    '2012q3'
    'PPU 2012:2'	'2012-09-05'    '2012q3'
%     'PPR 2012:3'	'2012-10-24'    '2012q4'
    'PPU 2012:3'	'2012-12-17'    '2012q4'
    'PPR 2013:1'	'2013-02-12'    '2013q1'
    'PPU 2013:1'	'2013-04-16'    '2013q2'
%     'PPR 2013:2'	'2013-07-02'    '2013q3'
    'PPU 2013:2'	'2013-09-04'    '2013q3'
};    


%% User control
round       = 'PPU 2010:2'; %'PPU 2009:2'; %'PPU 2013:2';
use_inno    = 0;    % indicator for whether innovation or shock is to be used when computing scenario
% use_forward = 1;    % indicator for whether market long rates or forward implied long rates are to be used


%% Retrieving data
cpif = SetupCPIFData;
gdp = SetupGDPData;
int = SetupIntData;

ShortRate   = SetupShortRateData;
LongRate    = SetupForwardData;

%% Retrieving IRFs
load('IRFs')

%% Computing shock and inno size

% creating container variables
Shock.inno      = nan(size(policy_rounds,1),1);
Shock.wedge        = nan(size(policy_rounds,1),1);
Shock.round     = cell(size(policy_rounds,1),1);
Shock.dates     = cell(size(policy_rounds,1),1);
Shock.quarter   = cell(size(policy_rounds,1),1);

% PPR 2007:1
round_index     = strcmp(policy_rounds(1,1), ShortRate.round(1,:));
tp_diff         = -100*(LongRate.longrates(4,round_index) - ShortRate.longrates(4,round_index));
Shock.inno(1,1)= tp_diff / IRFs.tpaU_uphiU_eps(1,1);
Shock.wedge(1:end,1) = Shock.inno(1,1) * IRFs.tpaU_uphiU_eps(1,1:size(Shock.wedge,1));
Shock.round(1,1) = policy_rounds(1,1);
Shock.dates(1,1) = policy_rounds(1,2);
Shock.quarter(1,1) = policy_rounds(1,3);

% PPR 2007:2
round_index     = strcmp(policy_rounds(2,1), ShortRate.round(1,:));
tp_diff         = -100*(LongRate.longrates(4,round_index) - ShortRate.longrates(4,round_index));
Shock.inno(2,1)  = (tp_diff - Shock.wedge(2,1)) / IRFs.tpaU_uphiU_eps(1,1);
Shock.wedge(2:end,1) = Shock.wedge(2:end,1) + Shock.inno(2,1) * IRFs.tpaU_uphiU_eps(1,1:size(Shock.wedge,1)-1)';
Shock.round(2,1)= policy_rounds(2,1);
Shock.dates(2,1) = policy_rounds(2,2);
Shock.quarter(2,1) = policy_rounds(2,3);

% Q3 2007 - no policy round
Shock.inno(3,1)  = 0;
Shock.round(3,1)= {'No round'};
Shock.dates(3,1) = policy_rounds(3,2);
Shock.quarter(3,1) = policy_rounds(3,3);

% PPU 2007:3
round_index     = strcmp(policy_rounds(4,1), ShortRate.round(1,:));
tp_diff         = -100*(LongRate.longrates(4,round_index) - ShortRate.longrates(4,round_index));
Shock.inno(4,1)  = (tp_diff - Shock.wedge(4,1)) / IRFs.tpaU_uphiU_eps(1,1);
Shock.wedge(4:end,1) = Shock.wedge(4:end,1) + Shock.inno(4,1) * IRFs.tpaU_uphiU_eps(1,1:size(Shock.wedge,1)-3)';
Shock.round(4,1)= policy_rounds(4,1);
Shock.dates(4,1) = policy_rounds(4,2);
Shock.quarter(4,1) = policy_rounds(4,3);

% remaining rounds
for i = 5:size(policy_rounds,1)
    round_index = strcmp(policy_rounds(i,1), ShortRate.round(1,:));
    tp_diff     = -100*(LongRate.longrates(4,round_index) - ShortRate.longrates(4,round_index));
    Shock.inno(i,1)  = (tp_diff - Shock.wedge(i,1)) / IRFs.tpaU_uphiU_eps(1,1);
    Shock.wedge(i:end,1) = Shock.wedge(i:end,1) + Shock.inno(i,1) * IRFs.tpaU_uphiU_eps(1,1:size(Shock.wedge,1)-(i-1))';
    Shock.round(i,1)= policy_rounds(i,1);
    Shock.dates(i,1)= policy_rounds(i,2);
    Shock.quarter(i,1)= policy_rounds(i,3);
    
end

Shock.shock = Shock.wedge / IRFs.tpaU_uphiU_eps(1,1);

%% Computing scenario
round_index_shock = strcmp(round, Shock.round(:,1));
round_index_var   = strcmp(round, int.round(1,:));


% Riksbank forecast
outc_end = find(int.outindex(:,round_index_var));
rb_forecast.cpif_yy = cpif.Data_yy(1:outc_end+12,round_index_var);
rb_forecast.cpif_qq = cpif.Data_qq(1:outc_end+12,round_index_var);
rb_forecast.gdp     = gdp.Data(1:outc_end+12,round_index_var);
rb_forecast.int     = int.Data(1:outc_end+12,round_index_var);

% alternative forecast
if use_inno == 0
    inno = Shock.shock(round_index_shock);
else
    inno = Shock.inno(round_index_shock);
end

% Alternative forecast cpif yy
dev = inno * IRFs.piyyU_uphiU_eps(1:12);
alt_forecast.cpif_yy = cpif.Data_yy(1:outc_end,round_index_var);
alt_forecast.cpif_yy = [alt_forecast.cpif_yy; cpif.Data_yy(outc_end+1:outc_end+12,round_index_var)+dev'];

% Alternative forecast cpif qq
dev = inno * IRFs.piaU_uphiU_eps(1:12);
alt_forecast.cpif_qq = cpif.Data_qq(1:outc_end,round_index_var);
alt_forecast.cpif_qq = [alt_forecast.cpif_qq; cpif.Data_qq(outc_end+1:outc_end+12,round_index_var)+dev'];

% Alternative forecast gdp
dev = inno * IRFs.yaU_uphiU_eps(1:12);
alt_forecast.gdp = gdp.Data(1:outc_end,round_index_var);
alt_forecast.gdp = [alt_forecast.gdp; gdp.Data(outc_end+1:outc_end+12,round_index_var)+dev'];

% Alternative forecast policy rate
dev = inno * IRFs.iaU_uphiU_eps(1:12);
alt_forecast.int  = int.Data(1:outc_end,round_index_var);
alt_forecast.int = [alt_forecast.int; int.Data(outc_end+1:outc_end+12,round_index_var)+dev'];

%% Plotting the scenario
xdata = datenum(int.dates(outc_end-12:outc_end+12,1));
tick = [xdata(4); xdata(12); xdata(20)];
    
% plotting gdp
figure(1)
    ha = plot(xdata(1:13,1), rb_forecast.gdp(outc_end-12:outc_end,1),...
        xdata(13:25,1), rb_forecast.gdp(outc_end:outc_end+12,1),...
        xdata(13:25,1), alt_forecast.gdp(outc_end:outc_end+12,1));
    set(ha(1), 'Linewidth', 2, 'Color',[0 1 0])
    set(ha(2), 'Linewidth', 2, 'Color',[0 0 1], 'Line', '-', 'Marker', 'o', 'MarkerSize',3)
    set(ha(3), 'Linewidth', 2, 'Color',[1 0 0], 'Line', '--')
    legend('Data', 'Riksbank forecast', 'Alternative forecast')
    title('GDP forecast')
    set(gca,'XTick',tick)
    datetick('x','yyyy-mm', 'keepticks')
    axis tight
 
% plotting cpif_yy
figure(2)
    ha = plot(xdata(1:13,1), rb_forecast.cpif_yy(outc_end-12:outc_end,1),...
        xdata(13:25,1), rb_forecast.cpif_yy(outc_end:outc_end+12,1),...
        xdata(13:25,1), alt_forecast.cpif_yy(outc_end:outc_end+12,1));
    set(ha(1), 'Linewidth', 2, 'Color',[0 1 0])
    set(ha(2), 'Linewidth', 2, 'Color',[0 0 1], 'Line', '-', 'Marker', 'o', 'MarkerSize',3)
    set(ha(3), 'Linewidth', 2, 'Color',[1 0 0], 'Line', '--')
    legend('Data', 'Riksbank forecast', 'Alternative forecast')
    title('Annual CPIF forecast')
    set(gca,'XTick',tick)
    datetick('x','yyyy-mm', 'keepticks')
    axis tight
    
% plotting cpif_yy
figure(3)
    ha = plot(xdata(1:13,1), rb_forecast.cpif_qq(outc_end-12:outc_end,1),...
        xdata(13:25,1), rb_forecast.cpif_qq(outc_end:outc_end+12,1),...
        xdata(13:25,1), alt_forecast.cpif_qq(outc_end:outc_end+12,1));
    set(ha(1), 'Linewidth', 2, 'Color',[0 1 0])
    set(ha(2), 'Linewidth', 2, 'Color',[0 0 1], 'Line', '-', 'Marker', 'o', 'MarkerSize',3)
    set(ha(3), 'Linewidth', 2, 'Color',[1 0 0], 'Line', '--')
    legend('Data', 'Riksbank forecast', 'Alternative forecast')
    title('Quarterly CPIF forecast, annualized')
    set(gca,'XTick',tick)
    datetick('x','yyyy-mm', 'keepticks')
    axis tight
    
% plotting repo
figure(4)
    ha = plot(xdata(1:13,1), rb_forecast.int(outc_end-12:outc_end,1),...
        xdata(13:25,1), rb_forecast.int(outc_end:outc_end+12,1),...
        xdata(13:25,1), alt_forecast.int(outc_end:outc_end+12,1));
    set(ha(1), 'Linewidth', 2, 'Color',[0 1 0])
    set(ha(2), 'Linewidth', 2, 'Color',[0 0 1], 'Line', '-', 'Marker', 'o', 'MarkerSize',3)
    set(ha(3), 'Linewidth', 2, 'Color',[1 0 0], 'Line', '--')
    legend('Data', 'Riksbank forecast', 'Alternative forecast')
    title('Policy rate forecast')
    set(gca,'XTick',tick)
    datetick('x','yyyy-mm', 'keepticks')
    axis tight    


