function cpif = SetupCPIFData

%% Reading data, defining policy rounds and last obs date
[cpif_forec,txt_forec,raw_forec]=xlsread('data2008_2013.xlsx','KPIF','a1:ai148');
% [data_outc,txt_outc,raw_outc]=xlsread('DataOutcomes_20130930.xlsx','Blad1','a1:e156');

policy_rounds = {  
    'PPU 2009:1'	'2009-02-15'
    'PPR 2009:2'	'2009-02-15'
    'PPU 2009:2'	'2009-05-15'
    'PPR 2009:3'	'2009-08-15'
    'PPU 2009:3'	'2009-08-15'
    'PPR 2010:1'	'2009-11-15'
    'PPU 2010:1'	'2010-02-15'
    'PPR 2010:2'	'2010-02-15'
    'PPU 2010:2'	'2010-05-15'
    'PPR 2010:3'	'2010-08-15'
    'PPU 2010:3'	'2010-08-15'
    'PPR 2011:1'	'2010-11-15'
    'PPU 2011:1'	'2011-02-15'
    'PPR 2011:2'	'2011-02-15'
    'PPU 2011:2'	'2011-05-15'
    'PPR 2011:3'	'2011-08-15'
    'PPU 2011:3'	'2011-08-15'
    'PPR 2012:1'	'2011-11-15'
    'PPU 2012:1'	'2012-02-15'
    'PPR 2012:2'	'2012-02-15'
    'PPU 2012:2'	'2012-05-15'
    'PPR 2012:3'	'2012-08-15'
    'PPU 2012:3'	'2012-08-15'
    'PPR 2013:1'	'2012-11-15'
    'PPU 2013:1'	'2013-02-15'
    'PPR 2013:2'	'2013-02-15'
    'PPU 2013:2'	'2013-05-15'};

%% Data handling
% picking out inf outcome data and dates
dates       = txt_forec(2:end,1);

%% Setting date format
for i = 1:size(dates,1)
    int_date = char(dates(i));
    if strcmp(int_date(6:7),'03') == 1
        month_date = '02';
    elseif strcmp(int_date(6:7),'06') == 1
        month_date = '05';
    elseif strcmp(int_date(6:7),'09') == 1
        month_date = '08';
    elseif strcmp(int_date(6:7),'12') == 1
        month_date = '11';        
    end
    date_str = [int_date(1:4), '-', month_date, '-15'];
    dates{i} = date_str;
end

%% Defining output structures
cpif.dates      = dates;
cpif.Data_qq    = nan(size(cpif_forec,1),size(policy_rounds,1));
cpif.Data_yy    = nan(size(cpif_forec,1),size(policy_rounds,1));
cpif.outindex   = nan(size(cpif_forec,1),size(policy_rounds,1));
cpif.round      = cell(1,size(policy_rounds,1));

%% Computations 
jj = 1;

for i = 1:size(policy_rounds,1)
    policy_round_index = strcmp(policy_rounds(i,1), txt_forec(1,2:end));     % picking policy round
    cpif.Data_qq(2:end,jj) = 400 * (log(cpif_forec(2:end, policy_round_index)./cpif_forec(1:end-1, policy_round_index)));      % computing forecast inf q/q 
    cpif.Data_yy(5:end,jj) = 100 * (log(cpif_forec(5:end, policy_round_index)./cpif_forec(1:end-4, policy_round_index)));      % computing forecast inf q/q 
    cpif.outindex(:,jj) = strcmp(policy_rounds(i,2), dates);
    cpif.round(1,jj) = policy_rounds(i,1);
    jj = jj + 1;
end